﻿define(['kendo', 'router', 'messenger'], function (kendo, router, messenger)
{
    var initialise = function ()
    {
        $.support.cors = true;

        kendo.culture("en-AU");
        router.start();


        $("#statusbar").kendoNotification({
            // insert all notifications to the widget's originating element
            appendTo: "#statusbar",
            position: {
                pinned: true,
                top: null,
                left: null,
                bottom: 0,
                right: 0
            },
            templates: [
                {
                    // define a custom template for the built-in "success" notification type
                    type: "success",
                    template: "<div style='width: 100%; height: 27px; vertical-align: middle; color: green; font-weight: bold; font-size: large; text-align: center; margin-top: 5px'>#= content #</div>"
                },
                {
                    // define a custom template for the built-in "info" notification type
                    type: "info",
                    template: "<div style='width: 100%; height: 27px; vertical-align: middle; color: green; font-weight: bold; font-size: large; text-align: center; margin-top: 5px'>#= content  #</div>"
                },
                {
                    // define a custom template for the built-in "warning" notification type
                    type: "warning",
                    template: "<div style='width: 100%; height: 27px; vertical-align: middle; color: darkgoldenrod; font-weight: bold; font-size: large; text-align: center; margin-top: 5px'>#= content #</div>"
                },
                {
                    // define a custom template for the built-in "error" notification type
                    type: "error",
                    template: "<div style='width: 100%; height: 27px; vertical-align: middle; color: red; font-weight: bold; font-size: large; text-align: center; margin-top: 5px'>#= content #</div>"
                }
            ]
        });

        $(function ()
        {
            // Reference the auto-generated proxy for the hub.  
            var infoHub = $.connection.infoHub;

            // Create a function that the hub can call back to display messages.
            infoHub.client.addNewMessageToPage = function (message, type)
            {
                messenger.sendMessage(message, type);
            };

            $.connection.hub.start().done(function ()
            {
                // Call the Send method on the hub. 
                //infoHub.server.sendInfoToAll($("#CurrentUserFullName").val()  + " logged in just now.");
            });
        });
    };

    return {
        initialise: initialise
    };
});