﻿define(['kendo',
    'text!views/makerequest/equipmentloan/equipmentloan.html',
    'models/equipmentrequest',
    'models/equipmentrequestdetail',
    'datafunctions/equipmentrequest',
    'messenger'
], function (kendo, viewTemplate, equipmentrequest, equipmentrequestdetail, equipmentrequestdf, messenger)
{
    var grid;
    var equipmentDataSource;

    var init = function (id)
    {
        var myCurrentRequest;

        myCurrentRequest = new equipmentrequest();
        myCurrentRequest.EquipmentRequestLines = [];

        if (id)
        {
            if (id > 0)
            {
                myCurrentRequest = equipmentrequestdf.getEquipmentRequest(id);

                if (!myCurrentRequest.EquipmentRequestLines)
                {
                    myCurrentRequest.EquipmentRequestLines = [];
                }
            }
        }

        // Define a DataSource
        equipmentDataSource = new kendo.data.DataSource({
            data: myCurrentRequest.EquipmentRequestLines,
            schema: {
                model: equipmentrequestdetail
            },
            error: function (e)
            {
                var xhr = e.xhr;
                var statusCode = e.status;
                var errorThrown = e.errorThrown;
                var msg = xhr.responseText;

                JL().error(errorThrown + ' ' + msg);
            }
        });

        var viewModel = kendo.observable({
            title: 'Equipment Loan',
            currentRequest: myCurrentRequest,
            equipmentDetailSource: equipmentDataSource,
            addEquipment: function (e)
            {

            },
            save: function ()
            {
                if (this.hasChanges)
                {
                    try
                    {
                        $("#elgrid").data("kendoGrid").saveChanges();

                        myCurrentRequest.CreatorBems = CurrentUserBems.value;
                        myCurrentRequest.ChangedByBems = CurrentUserBems.value;

                        var isSuccessful = equipmentrequestdf.saveEquipmentRequest(myCurrentRequest);

                        if (isSuccessful)
                        {
                            messenger.sendMessage("Equipment Request saved successfully!", "success");
                        }
                        else
                        {
                            messenger.sendMessage("Unable to save Equipment Request!", "error");
                        }
                    }
                    catch (ex)
                    {
                        JL().error(ex.message);
                    }

                    this.set("hasChanges", false);
                }
            },
            change: function ()
            {
                this.set("hasChanges", true);
            },
            hasChanges: false,
        });

        var view = new kendo.View(viewTemplate, {
            model: viewModel,
            init: function (e)
            {
                if (!grid)
                {
                    grid = $("#elgrid").data("kendoGrid");
                }

                $(".k-grid-toolbar").delegate(".k-grid-add", "click", function (e)
                {
                    e.preventDefault();
                    grid.addRow();
                });
            },
            show: function (e)
            {

            }
        });

        kendo.bind($("#form-container"), viewModel);

        return view;
    }

    return init;

});