﻿define([
    'kendo',
    'text!views/menu/menu.html'
], function (kendo, menuTemplate)
{
    var nav;

    // these links populate the navbar
    var viewModel = kendo.observable({
        links: [
           // { title: 'Home', href: '#/?menu=true', icon: 'home', icon: 'fa fa-home' },
            { title: 'Make a Request', href: '#/makerequest?menu=true', icon: 'home', icon: 'fa fa-home' },
            { title: 'Approve a Request', href: '#/approverequest?menu=true', icon: '' }
        ]
    });

    if ($("#CurrentUserIsAdmin").val() == "True")
    {
        viewModel.links.push({ title: 'Admin', href: '#/admin?menu=true', icon: '' });
    }

    var menu = new kendo.Layout(menuTemplate, {
        model: viewModel,
        init: function (e)
        {
            // cache a reference to the nav links element
            nav = e.sender.element.find('#nav-links');
        }
    });

    $.subscribe('/menu/change', function (e)
    {
        if (e.url)
        {
            setActiveMenuState(e.url);
        }
    });

    var setActiveMenuState = function (url)
    {
        if (nav)
        {
            url = "/" + url.split("?")[0].split("#")[0].split("/")[1] + "?menu=true";

            if (url)
            {
                // select a nav link based on the current route
                var active = nav.find('a[href="#' + url + '"]').parent();

                // if the nav link exists...
                if (active.length > 0)
                {
                    // remove the active class from all links
                    nav.find('li').removeClass('k-state-highlight k-state-default k-state-hover');

                    // add the active class to the current link
                    active.addClass('k-state-highlight k-state-default k-state-hover');
                }
            }
        }
    }


    return {
        
        menu: menu,
        setActiveMenuState :setActiveMenuState
        
        };

});