﻿define([
    'text!views/sidebar/sidebar.html'
], function (sidebarTemplate)
{
    var sidebar = {};

    var sb;

    $.subscribe('/sidemenu/change', function (e)
    {
        if (e.url)
        {
            var url = e.url.split("?")[0].split("#")[0];

            if (url)
            {
                setActiveSideMenuState(url);
            }
        }
    });

    function setActiveSideMenuState(url)
    {
        if (sb)
        {
            // select a nav link based on the current route
            var active = sb.find('a[href="#' + url + '"]');

            // if the nav link exists...
            if (active.length > 0)
            {
                // remove the active class from all links
                sb.find('a').removeClass('activesidemenu');

                // add the active class to the current link
                active.addClass('activesidemenu');
            }
        }
    }

    var init = function (url)
    {
        if (url)
        {
            url = url.split("?")[0].split("#")[0];

            var menuItem = url.split("/")[1];
            var sideMenuItem = url.split("/")[2];

            // these links populate the sidebar
            var sideBarViewModel;

            switch (menuItem)
            {
                case "makerequest":
                    sideBarViewModel = kendo.observable({
                        links: [
                            { title: 'Folder Access', href: '#/makerequest/folderaccess', icon: '' },
                            { title: 'Software Access', href: '#/makerequest/softwareaccess', icon: '' },
                            { title: 'Equipment Acquisition', href: '#/makerequest/equipmentacquisition', icon: '' },
                            { title: 'Equipment Loan', href: '#/makerequest/equipmentloan', icon: '' }
                        ]
                    });

                    if (!sideMenuItem)
                    {
                        //Set default side menu url
                        url = '/makerequest/folderaccess';

                        //save default for side menu
                        $("#CurrentSideMenu").val("folderaccess");
                    }
                    break;
                case "approverequest":
                    sideBarViewModel = kendo.observable({
                        links: [
                            { title: 'Folder Access', href: '#/approverequest/folderaccess', icon: '' },
                            { title: 'Software Access', href: '#/approverequest/softwareaccess', icon: '' }
                        ]
                    });

                    if (!sideMenuItem)
                    {
                        //Set default side menu url
                        url = '/approverequest/folderaccess';

                        //save default for side menu
                        $("#CurrentSideMenu").val("folderaccess");
                    }
                    break;
                case "admin":
                    sideBarViewModel = kendo.observable({
                        links: []
                    });

                    if (!sideMenuItem)
                    {
                        //Set default side menu url
                        url = '/admin/manageequipment';

                        //save default for side menu
                        $("#CurrentSideMenu").val("manageequipment");
                    }
                    break;
                default:
                    sideBarViewModel = kendo.observable({
                        links: [
                            { title: 'Folder Access', href: '#/makerequest/folderaccess', icon: '' },
                            { title: 'Software Access', href: '#/makerequest/softwareaccess', icon: '' },
                            { title: 'Equipment Acquisition', href: '#/makerequest/equipmentacquisition', icon: '' },
                            { title: 'Equipment Loan', href: '#/makerequest/equipmentloan', icon: '' }
                        ]
                    });

                    if (!sideMenuItem)
                    {
                        //Set default side menu url
                        url = '/makerequest/folderaccess';

                        //save default for side menu
                        $("#CurrentSideMenu").val("folderaccess");
                    }
                    break;
            }

            if (sideBarViewModel)
            {
                sidebar = new kendo.Layout(sidebarTemplate, {
                    model: sideBarViewModel,
                    init: function (e)
                    {
                        // cache a reference to the sidebar links element
                        sb = e.sender.element.find('#sidebar-links');

                        setActiveSideMenuState(url);
                    },
                    show: function (e)
                    {

                    }
                });
            }
        }

        return sidebar;
    }


    return init;
});