﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Mvvm_SPA.Hubs;
using Microsoft.AspNet.SignalR;

namespace Mvvm_SPA.Helpers
{
    public static class Messages
    {
        public static void SendMessageToAll(string message, MessageType type)
        {
            var context = GlobalHost.ConnectionManager.GetHubContext<InfoHub>();
            context.Clients.All.addNewMessageToPage(message, type.ToString().ToLower());
        }

        public static void SendMessageToAll(string message)
        {
            var context = GlobalHost.ConnectionManager.GetHubContext<InfoHub>();
            context.Clients.All.addNewMessageToPage(message);
        }

        public static void SendMessageToCurrentUser(string message, MessageType type)
        {
            if(HttpContext.Current != null && HttpContext.Current.User != null && HttpContext.Current.User.Identity != null && !string.IsNullOrEmpty(HttpContext.Current.User.Identity.Name))
            {
                SendMessageToUser(HttpContext.Current.User.Identity.Name, message, type);
            }
        }

        public static void SendMessageToCurrentUser(string message)
        {
            if(HttpContext.Current != null && HttpContext.Current.User != null && HttpContext.Current.User.Identity != null && !string.IsNullOrEmpty(HttpContext.Current.User.Identity.Name))
            {
                SendMessageToUser(HttpContext.Current.User.Identity.Name, message);
            }
        }

        public static void SendMessageToUser(string userIdentityName, string message, MessageType type)
        {
            var context = GlobalHost.ConnectionManager.GetHubContext<InfoHub>();
            context.Clients.User(userIdentityName).addNewMessageToPage(message, type.ToString().ToLower());
        }

        public static void SendMessageToUser(string userIdentityName, string message)
        {
            var context = GlobalHost.ConnectionManager.GetHubContext<InfoHub>();
            context.Clients.User(userIdentityName).addNewMessageToPage(message);
        }

        public enum MessageType
        {
            Info = 0,
            Error = 1,
            Success = 2,
            Warning = 3
        }
    }
}