﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web;

namespace Mvvm_SPA.Helpers
{
    public class MinimumCollectionSizeAttribute : ValidationAttribute
    {
        private int _minSize;
        public MinimumCollectionSizeAttribute(int minSize)
        {
            _minSize = minSize;
        }

        public override bool IsValid(object value)
        {
            if(value == null)
                return true;

            var list = value as ICollection;

            if(list == null)
                return true;

            return list.Count >= _minSize;
        }
    }
}